habib_rahman's blog

By habib_rahman, history, 7 years ago, In English

Given N distinct integers from 1 to N, you have to find the number of ways the N integers can be rearranged in M empty slots such that, no integer matches with its slot index. Note that, slots are indexed from 1 to M.

Print the number of ways modulo 23377788.

0<=N<=M<100000 and It has 200 test cases.

I came up with a solution like this but not sure its correct or not. And have not any idea to modulu it by non prime.

Full text and comments »

  • Vote: I like it
  • -7
  • Vote: I do not like it

By habib_rahman, history, 7 years ago, In English

I want to do binary search on a multiset, because I need to know "How many elements in the multiset greater or equal to x". And obviously I want to get the data in O(logn).

Full text and comments »

  • Vote: I like it
  • 0
  • Vote: I do not like it

By habib_rahman, history, 7 years ago, In English

Problem:

As Harry Potter series is over, Harry has no job. Since he wants to make quick money, (he wants everything quick!) so he decided to rob banks. He wants to make a calculated risk, and grab as much money as possible. But his friends — Hermione and Ron have decided upon a tolerable probability P of getting caught. They feel that he is safe enough if the banks he robs together give a probability less than P.

Input

Input starts with an integer T (≤ 100), denoting the number of test cases.

Each case contains a real number P, the probability Harry needs to be below, and an integer N (0 < N ≤ 100), the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj (0 < Mj ≤ 100) and a real number Pj . Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj. A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Output

For each case, print the case number and the maximum number of millions he can expect to get while the probability of getting caught is less than P.

Sample Input

3

0.04 3

1 0.02

2 0.03

3 0.05

0.06 3

2 0.03

2 0.03

3 0.05

0.10 3

1 0.03

2 0.02

3 0.05

Sample Output:

Case 1: 2

Case 2: 4

Case 3: 6

Note:

For the first case, if he wants to rob bank 1 and 2, then the probability of getting caught is 0.02 + (1 — 0.02) * .03 = 0.0494 which is greater than the given probability (0.04). That's why he has only option, just to rob rank 2.

I had seen many solution in web where they calculated as:

for i = sum_of_millions to 1

    for j=1 to all bank

        dp[i][j] ....

My thought is why I should go for millions? Shouldn't I go by bank or not?

Full text and comments »

Tags dp
  • Vote: I like it
  • -13
  • Vote: I do not like it

By habib_rahman, history, 7 years ago, In English

Actually, I can find the dp states for a problem on average. But for every problem i can't maintain the base case. So, I want tricks from you.

Full text and comments »

Tags #dp
  • Vote: I like it
  • +11
  • Vote: I do not like it